#include <iostream>
#include <cstdarg>

class TensorIndex
	{
	public:
		int dim, id, siblingCount;
		const TensorIndex *nextIndex;

		// Constructors
		TensorIndex(): dim(0), id(0), siblingCount(0), nextIndex(NULL) { }

		TensorIndex(const TensorIndex &tensorIndex, bool variate = false):
			dim(tensorIndex.dim), id((variate?-1:1)*tensorIndex.id),
			siblingCount(tensorIndex.siblingCount), nextIndex(tensorIndex.nextIndex) { }
		TensorIndex(const int dimension): dim(dimension), id(nextIndexId++), siblingCount(0), nextIndex(NULL) { }

		// Functions
		TensorIndex cov()	const { return TensorIndex(*this, true);	}
		TensorIndex covariant()	const { return TensorIndex(*this, true);	}

		const TensorIndex operator*(const TensorIndex &index) const
			{ return TensorIndex(index.dim, index.id, 1 + siblingCount, this); }

	private:
		TensorIndex(const int dimension, const int ident, const int sibCount, const TensorIndex * const nextId ):
			dim(dimension), id(ident), siblingCount(sibCount), nextIndex(nextId) { }
		static int nextIndexId;
	};

int TensorIndex::nextIndexId = 1;

class Tensor
	{
	public:
		Tensor(const Tensor &tensor)	{}
		Tensor(const TensorIndex &index): numDims(index.siblingCount+1), indexId(new int[numDims]), dimensions(new int[numDims])
			{
			int i;
			TensorIndex const (*indexPtr);
			for (i = numDims -1, indexPtr = &index; i >=0; i--, indexPtr = indexPtr->nextIndex)
				{
				indexId[i] = indexPtr->id;
				dimensions[i] = indexPtr->dim;
				}
			}

		int numDims, *indexId;

		// This can go to a sharedData !!¡¡
		int *dimensions;
		//double *data;
	};

///////////////////////////////////////////////////////////////////

//#define	ABS(X)	((X>0)?(X):(-X))
std::ostream& operator<<( std::ostream &os, const TensorIndex &tensorIndex)
	{
	//if (tensorIndex.nextIndex != NULL)
	//	os << *(tensorIndex.nextIndex) << ", ";
	os << ((tensorIndex.id<0)?"cov ":"") << tensorIndex.dim;
	/*os << ((tensor.indexes[0].id<0)?"cov ":"") << tensor.indexes[0].dim;
	for (int i=1; i<tensor.numDims; i++)
		os << ", " << ((tensor.indexes[i].id<0)?"cov ":"") << tensor.indexes[i].dim;*/
	return os;
	}

std::ostream& operator<<( std::ostream &os, const Tensor &tensor)
	{
	os << "Tensor (";
	os << tensor.dimensions[0];
	for (int i=1; i<tensor.numDims; i++)
		os << ", " << tensor.dimensions[i];
	os << ")";
	return os;
	}

main ()
	{

	TensorIndex i = 7, j = 13, k = 23, l = j.cov();

	Tensor	A(i * j * k * j.cov());

	std::cout << "A = " << A << std::endl;
	}

//////////////////////////////////////////////////////////////////////////////////////////////

/*std::ostream& operator<<( std::ostream &os, const TensorIndex &tensorIndex)
	{
	//if (tensorIndex.nextIndex != NULL)
	//	os << *(tensorIndex.nextIndex) << ", ";
	os << ((tensorIndex.id<0)?"cov ":"") << tensorIndex.dim;
	}*/

/*Tensor(const int nDims, TensorIndex *index1, ...): numDims(nDims), indexes(new TensorIndex[numDims])
	{
	va_list marker;
	va_start(marker, index1);

	TensorIndex *idx = index1;
	for (int i = 0; i < nDims; i++)
		{
		indexes[i] = *idx;
		idx = va_arg(marker, TensorIndex *);
		}
	va_end(marker);
	}

Tensor(const int nDims, const int dim1, ...): numDims(nDims), indexes(new TensorIndex[numDims])
	{
	va_list marker;
	va_start(marker, dim1);

	int actualdim = dim1;
	for (int i = 0; i < nDims; i++)
		{
		indexes[i].dim = ABS(actualdim);
		indexes[i].id = (actualdim>0)?1:-1;
		actualdim = va_arg(marker, int);
		}
	va_end(marker);
	}*/

